import React, { PureComponent } from "react";
import {
  Platform,
  StyleSheet,
  Text,
  Alert,
  TouchableHighlight,
  TextInput,
  Button,
  View,
  PermissionsAndroid,
  Keyboard,
  ScrollView
} from "react-native";
import PropTypes from "prop-types";

//import { registerScreens } from "./screens";
// import { Navigation } from "react-native-navigation";
import axios from "react-native-axios";
import Logo from "./Logo";
import { each } from "underscore";

type Props = {};
export default class App extends PureComponent {
  infos: string;
  res_token: string;
  static propTypes = {
    componentId: PropTypes.string
  };

  static options(passProps) {
    return {
      topBar: {
        visible: true,
        animate: true,
        title: {
          text: "Enablex",
          fontSize: 20,
          color: "white"
        },
        background: {
          color: "#6f5989"
        }
      },
      statusBar: {
        backgroundColor: "#534367",
        visible: true,
        style: "light"
      }
    };
  }
  constructor(props) {
    super(props);
    this.state = {

      user_name: "RN",
      pin: "438823",
      permissionsError: false
    };
    // Navigation.events().bindComponent(this);
    this._onJoin_Room = this._onJoin_Room.bind(this);
    this.getRoomByPinWebCall = this.getRoomByPinWebCall.bind(this);
    this.getRoomTokenWebCall = this.getRoomTokenWebCall.bind(this);
    this.navigateToVideo = this.navigateToVideo.bind(this);
  }
  render() {
    console.log("ajscjsacjs");
    return (
      <ScrollView
        contentContainerStyle={{ flexGrow: 1 }}
        keyboardShouldPersistTaps="handled"
      >
        <View style={styles.container}>
          <Logo />
          <View style={{ marginTop: 10 }}>
            <TextInput
              style={{
                height: 40,
                width: 300,
                borderColor: "#eae7e7",
                backgroundColor: "#eae7e7",
                borderWidth: 2,
                borderRadius: 10,
                marginBottom: 20,
                alignSelf: "center"
              }}
              placeholder="Enter name"
              ref={"textInput1"}
              keyboardType={"default"}
              autoCapitalize={"none"}
              editable={true}
              onChangeText={user_name => this.setState({ user_name })}
              value={this.state.user_name}
              returnKeyType={"next"}
              onSubmitEditing={event => {
                this.refs.textInput2.focus();
              }}
              autoCorrect={false}
              placeholderTextColor="#757575"
              underlineColorAndroid="transparent"
            />

            <TextInput
              style={{
                height: 40,
                width: 300,
                borderColor: "#eae7e7",
                backgroundColor: "#eae7e7",
                borderWidth: 2,
                borderRadius: 10,
                marginBottom: 20,
                alignSelf: "center"
              }}
              placeholder="Enter pin"
              autoCapitalize={"none"}
              ref={"textInput2"}
              editable={true}
              onChangeText={pin => this.setState({ pin })}
              value={this.state.pin}
              keyboardType={"default"}
              returnKeyType={"next"}
              autoCorrect={false}
              placeholderTextColor="#757575"
              underlineColorAndroid="transparent"
            />
          </View>
          <View
          style={{
            flex: 1,
            alignItems: "center",
            flexDirection: "row",
            alignSelf: "center"
          }}
        >
          <TouchableHighlight
            style={{
              height: 40,
              width: 150,
              borderColor: "#534367",
              backgroundColor: "#534367",
              borderWidth: 2,
              borderRadius: 20,
              marginBottom: 20,
              alignSelf: "center"
            }}
            underlayColor="transparent"
            onPress={this._onJoin_Room}
          >
            <Text style={styles.continue_button}>Join</Text>
          </TouchableHighlight>
          </View>
        </View>
      </ScrollView>
    );
  }

  _onJoin_Room = () => {
    console.log("Allllll INNNNNNN")
    if (this.state.user_name == "" && this.state.pin == "") {
      alert("Please enter your details");
    } else if (this.state.user_name == "") {
      alert("Please enter your name");
    } else if (this.state.pin == "") {
      alert("Please enter pin");
    } else {
      if (Platform.OS === "android") {
        checkAndroidPermissions()
          .then(() => {
            console.log("joinRoom", "EnxRoom.js");
            this.navigateToVideo();
          })
          .catch(error => {
            this.setState({ permissionsError: true });
            this.navigateToVideo();
            console.log("checkAndroidPermissions", error);
          });
      } else {
        console.log("initStreamElse");
        this.navigateToVideo();
      }
      // this.navigateToVideo();
    }
  };

  async getRoomByPinWebCall() {
    console.log("getRoomByPinWebCall");
    await axios
      .post("https://vc-mt.vcloudx.com/getRoomByPin/", {
        pin: this.state.pin
      })
      .then(function(response) {
        this.infos = response.data;
        console.log("axiosResponseinfo", this.infos);
      })
      .catch(function(error) {
        console.log("axiosError", error);
      });
  }

  async getRoomTokenWebCall() {
    console.log("getRoomTokenWebCall");
    await this.getRoomByPinWebCall();
//https://vc-mt.vcloudx.com/
//https://meeting-demo-qa.enablex.io/

    await axios
      .post("https://vc-mt.vcloudx.com/createToken/", {
        name: this.state.user_name,
        role: infos.role,
        user_ref: "2236",
        roomId: infos.room_id
      })
      .then(function(response) {
        this.res_token = response.data;
        console.log("axiosResponsetoken", this.res_token);
      })
      .catch(function(error) {
        console.log("axiosResponse", error);
      });
  }

  async navigateToVideo() {
    // const { navigate } = this.props;
    const { navigate } = this.props.navigation;

    console.log("navigateToVideo");
    await this.getRoomTokenWebCall();
    try {
      if (res_token.result == 0) {
        console.log("tokennnnnn:", res_token);
        console.log("usernameeeeee:", this.state.user_name);
        console.log("permissionsErrorrrr:", this.state.permissionsError);
        console.log("this.props.componentIdddd:", this.props.componentId);
        // navigate("DashboardScreen")
        navigate('EnxConferenceScreen', {

          token: res_token.token
         
         });
        // Navigation.push(this.props.componentId, {
        //   component: {
        //     name: "EnxConferenceScreen",
        //     passProps: {
        //       token: res_token.token,
        //       username: this.state.user_name,
        //       permissionsError: this.state.permissionsError
        //     }
        //   }
        // });
      } else {
        console.log(res_token.error);
      }
    } catch (error) {
      console.log("navigationErroreeee", error);
    }
  }
}

const checkAndroidPermissions = () =>
  new Promise((resolve, reject) => {
    PermissionsAndroid.requestMultiple([
      PermissionsAndroid.PERMISSIONS.CAMERA,
      PermissionsAndroid.PERMISSIONS.RECORD_AUDIO,
      PermissionsAndroid.PERMISSIONS.WRITE_EXTERNAL_STORAGE,
      PermissionsAndroid.PERMISSIONS.READ_EXTERNAL_STORAGE
    ])
      .then(result => {
        const permissionsError = {};
        permissionsError.permissionsDenied = [];
        each(result, (permissionValue, permissionType) => {
          if (permissionValue === "denied") {
            console.log("denied Permission");
            permissionsError.permissionsDenied.push(permissionType);
            permissionsError.type = "Permissions error";
          }
        });
        if (permissionsError.permissionsDenied.length > 0) {
          console.log("denied Permission");
          reject(permissionsError);
        } else {
          console.log("granted Permission");
          resolve();
        }
      })
      .catch(error => {
        reject(error);
      });
  });

const styles = StyleSheet.create({
  container: {
    marginLeft: 10,
    marginRight: 10,
    marginBottom: 10
  },
  continue_button: {
    color: "white",
    fontSize: 16,
    alignSelf: "center",
    justifyContent: "center"
  }
});
